#define	uint					unsigned int
#define ulong					unsigned long

#define INETCOOKIE 0x494e45554L		/*  "INET" */
#define INETCOOKIEVAL 0x47444f53L	/*  "GDOS" */

/* Fehlernummern fr AP_ERR */
#define PERMFAULT   -1      /* no permission for login  */
#define SEQNFAULT   -2      /* falsche Sequenznummer    */
#define TYPEFAULT   -3      /* falsche Paket-Art    */
#define SERVFAULT   -4      /* falscher Service */
#define TIMEFAULT   -5      /* Ports berlastet */
#define NOSPFAULT	-6		/* Kein Platz im Speicher */
#define NEEDPASWD	-7		/* Client soll Passwort abfragen */
#define NETERROR	-1		/* Netzwerk-Fehler */
#define NETERR		-1		/* Netzwerk-Fehler */

/* DESTI Struktur fr Parameterbergabe */
typedef struct sdest
{
	unsigned int		Port;
	unsigned char		IPAddr[4];
} DESTI;

/* TCP-Verbindungsstatus */
#define		CLOSED			0
#define		LISTEN			1
#define		SYN_SENT		2
#define		SYN_RECEIVED	3
#define		ESTABLISHED		4
#define		FIN_WAIT_1		5
#define		FIN_WAIT_2		6
#define		CLOSE_WAIT		7
#define		CLOSING			8
#define		LAST_ACK		9
#define		TIME_WAIT		10

/* TCP-Open-Mode */
#define		AKTIV		1
#define		PASSIV		2
#define		PUSH		1
#define		NO_PUSH		0
#define		URGENT		1
#define		NO_URGENT	0

typedef struct inetstat
{
 TCP_TCB **tcpcb_list;
 UDP_CTL **udp_list;
 PKTQUEUE **ip_qrecv;
 long *arp_counts;
 long *icmp_counts;
 long *udp_counts;
 long *tcp_counts;
}INETSTAT;


/* TCP-Statusblock fuer tcp_stat() */
typedef struct stcpst
{
	uint		TCP_ID;
	uint		TCP_Port;
	DESTI		TCP_Dest;
	uint		TCP_State;
	long		TCP_Urgent;
	int			TCP_Timeout;
	ulong		TCP_RWin;
	ulong		TCP_RWfree;
} TCPSTAT;
